"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const winston = require("winston");
let logger;
exports.logger = logger;
winston.level = process.env.NVIM_NODE_LOG_LEVEL || 'debug';
let transports = [];
if (process.env.NVIM_NODE_LOG_FILE) {
    transports.push(new winston.transports.File({
        filename: process.env.NVIM_NODE_LOG_FILE,
        level: winston.level,
        json: false,
    }));
}
if (process.env.ALLOW_CONSOLE) {
    transports.push(winston.transports.Console);
}
exports.logger = logger = new winston.Logger({
    level: process.env.NVIM_NODE_LOG_LEVEL || 'debug',
    transports,
});
