/// <reference types="node" />
import { EventEmitter } from 'events';
import * as msgpack from 'msgpack-lite';
declare class Transport extends EventEmitter {
    private pending;
    private nextRequestId;
    private encodeStream;
    private decodeStream;
    private reader;
    private writer;
    protected codec: msgpack.Codec;
    constructor();
    setupCodec(): msgpack.Codec;
    attach(writer: NodeJS.WritableStream, reader: NodeJS.ReadableStream): void;
    detach(): void;
    request(method: string, args: any[], cb: Function): void;
    notify(method: string, args: any[]): void;
    parseMessage(msg: any[]): void;
}
export { Transport };
